/* PasswordManager.c generated by valac 0.42.0, the Vala compiler
 * generated from PasswordManager.vala, do not modify */

/*
* Copyright (c) 2011-2018 Alecaddd (http://alecaddd.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alessandro "Alecaddd" Castellani <castellani.ale@gmail.com>
*/


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <libsecret/secret.h>


#define SEQUELER_SERVICES_TYPE_PASSWORD_MANAGER (sequeler_services_password_manager_get_type ())
#define SEQUELER_SERVICES_PASSWORD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEQUELER_SERVICES_TYPE_PASSWORD_MANAGER, SequelerServicesPasswordManager))
#define SEQUELER_SERVICES_PASSWORD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEQUELER_SERVICES_TYPE_PASSWORD_MANAGER, SequelerServicesPasswordManagerClass))
#define SEQUELER_SERVICES_IS_PASSWORD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEQUELER_SERVICES_TYPE_PASSWORD_MANAGER))
#define SEQUELER_SERVICES_IS_PASSWORD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEQUELER_SERVICES_TYPE_PASSWORD_MANAGER))
#define SEQUELER_SERVICES_PASSWORD_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEQUELER_SERVICES_TYPE_PASSWORD_MANAGER, SequelerServicesPasswordManagerClass))

typedef struct _SequelerServicesPasswordManager SequelerServicesPasswordManager;
typedef struct _SequelerServicesPasswordManagerClass SequelerServicesPasswordManagerClass;
typedef struct _SequelerServicesPasswordManagerPrivate SequelerServicesPasswordManagerPrivate;
enum  {
	SEQUELER_SERVICES_PASSWORD_MANAGER_0_PROPERTY,
	SEQUELER_SERVICES_PASSWORD_MANAGER_NUM_PROPERTIES
};
static GParamSpec* sequeler_services_password_manager_properties[SEQUELER_SERVICES_PASSWORD_MANAGER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef struct _SequelerServicesPasswordManagerStorePasswordAsyncData SequelerServicesPasswordManagerStorePasswordAsyncData;
typedef struct _SequelerServicesPasswordManagerGetPasswordAsyncData SequelerServicesPasswordManagerGetPasswordAsyncData;
typedef struct _SequelerServicesPasswordManagerClearPasswordAsyncData SequelerServicesPasswordManagerClearPasswordAsyncData;
typedef struct _SequelerServicesPasswordManagerClearAllPasswordsAsyncData SequelerServicesPasswordManagerClearAllPasswordsAsyncData;

struct _SequelerServicesPasswordManager {
	GObject parent_instance;
	SequelerServicesPasswordManagerPrivate * priv;
};

struct _SequelerServicesPasswordManagerClass {
	GObjectClass parent_class;
	void (*store_password_async) (SequelerServicesPasswordManager* self, const gchar* id, const gchar* password, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*store_password_finish) (SequelerServicesPasswordManager* self, GAsyncResult* _res_, GError** error);
	void (*get_password_async) (SequelerServicesPasswordManager* self, const gchar* id, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gchar* (*get_password_finish) (SequelerServicesPasswordManager* self, GAsyncResult* _res_, GError** error);
	void (*clear_password_async) (SequelerServicesPasswordManager* self, const gchar* id, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*clear_password_finish) (SequelerServicesPasswordManager* self, GAsyncResult* _res_, GError** error);
	void (*clear_all_passwords_async) (SequelerServicesPasswordManager* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*clear_all_passwords_finish) (SequelerServicesPasswordManager* self, GAsyncResult* _res_, GError** error);
};

struct _SequelerServicesPasswordManagerStorePasswordAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	SequelerServicesPasswordManager* self;
	gchar* id;
	gchar* password;
	GHashTable* attributes;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* key_name;
	gchar* _tmp7_;
	gboolean _result_;
	SecretSchema* _tmp8_;
	GError * _inner_error_;
};

struct _SequelerServicesPasswordManagerGetPasswordAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	SequelerServicesPasswordManager* self;
	gchar* id;
	gchar* result;
	GHashTable* attributes;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* key_name;
	gchar* _tmp7_;
	gchar* password;
	SecretSchema* _tmp8_;
	gchar* _tmp9_;
	GError * _inner_error_;
};

struct _SequelerServicesPasswordManagerClearPasswordAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	SequelerServicesPasswordManager* self;
	gchar* id;
	GHashTable* attributes;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* key_name;
	gchar* _tmp7_;
	gboolean removed;
	SecretSchema* _tmp8_;
	GError * _inner_error_;
};

struct _SequelerServicesPasswordManagerClearAllPasswordsAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	SequelerServicesPasswordManager* self;
	GHashTable* attributes;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean removed;
	SecretSchema* _tmp5_;
	GError * _inner_error_;
};


static gpointer sequeler_services_password_manager_parent_class = NULL;
extern SecretSchema* sequeler_schema;

GType sequeler_services_password_manager_get_type (void) G_GNUC_CONST;
static void sequeler_services_password_manager_real_store_password_async_data_free (gpointer _data);
static void sequeler_services_password_manager_real_store_password_async_async_ready_wrapper (GObject *source_object,
                                                                                       GAsyncResult *res,
                                                                                       void *user_data);
static void sequeler_services_password_manager_real_store_password_async (SequelerServicesPasswordManager* self,
                                                                   const gchar* id,
                                                                   const gchar* password,
                                                                   GAsyncReadyCallback _callback_,
                                                                   gpointer _user_data_);
void sequeler_services_password_manager_store_password_async (SequelerServicesPasswordManager* self,
                                                              const gchar* id,
                                                              const gchar* password,
                                                              GAsyncReadyCallback _callback_,
                                                              gpointer _user_data_);
void sequeler_services_password_manager_store_password_finish (SequelerServicesPasswordManager* self,
                                                               GAsyncResult* _res_,
                                                               GError** error);
static gboolean sequeler_services_password_manager_real_store_password_async_co (SequelerServicesPasswordManagerStorePasswordAsyncData* _data_);
static void _g_free0_ (gpointer var);
#define CONSTANTS_PROJECT_NAME "com.github.alecaddd.sequeler"
static void sequeler_services_password_manager_store_password_async_ready (GObject* source_object,
                                                                    GAsyncResult* _res_,
                                                                    gpointer _user_data_);
static void sequeler_services_password_manager_real_get_password_async_data_free (gpointer _data);
static void sequeler_services_password_manager_real_get_password_async_async_ready_wrapper (GObject *source_object,
                                                                                     GAsyncResult *res,
                                                                                     void *user_data);
static void sequeler_services_password_manager_real_get_password_async (SequelerServicesPasswordManager* self,
                                                                 const gchar* id,
                                                                 GAsyncReadyCallback _callback_,
                                                                 gpointer _user_data_);
void sequeler_services_password_manager_get_password_async (SequelerServicesPasswordManager* self,
                                                            const gchar* id,
                                                            GAsyncReadyCallback _callback_,
                                                            gpointer _user_data_);
gchar* sequeler_services_password_manager_get_password_finish (SequelerServicesPasswordManager* self,
                                                               GAsyncResult* _res_,
                                                               GError** error);
static gboolean sequeler_services_password_manager_real_get_password_async_co (SequelerServicesPasswordManagerGetPasswordAsyncData* _data_);
static void sequeler_services_password_manager_get_password_async_ready (GObject* source_object,
                                                                  GAsyncResult* _res_,
                                                                  gpointer _user_data_);
static void sequeler_services_password_manager_real_clear_password_async_data_free (gpointer _data);
static void sequeler_services_password_manager_real_clear_password_async_async_ready_wrapper (GObject *source_object,
                                                                                       GAsyncResult *res,
                                                                                       void *user_data);
static void sequeler_services_password_manager_real_clear_password_async (SequelerServicesPasswordManager* self,
                                                                   const gchar* id,
                                                                   GAsyncReadyCallback _callback_,
                                                                   gpointer _user_data_);
void sequeler_services_password_manager_clear_password_async (SequelerServicesPasswordManager* self,
                                                              const gchar* id,
                                                              GAsyncReadyCallback _callback_,
                                                              gpointer _user_data_);
void sequeler_services_password_manager_clear_password_finish (SequelerServicesPasswordManager* self,
                                                               GAsyncResult* _res_,
                                                               GError** error);
static gboolean sequeler_services_password_manager_real_clear_password_async_co (SequelerServicesPasswordManagerClearPasswordAsyncData* _data_);
static void sequeler_services_password_manager_clear_password_async_ready (GObject* source_object,
                                                                    GAsyncResult* _res_,
                                                                    gpointer _user_data_);
static void sequeler_services_password_manager_real_clear_all_passwords_async_data_free (gpointer _data);
static void sequeler_services_password_manager_real_clear_all_passwords_async_async_ready_wrapper (GObject *source_object,
                                                                                            GAsyncResult *res,
                                                                                            void *user_data);
static void sequeler_services_password_manager_real_clear_all_passwords_async (SequelerServicesPasswordManager* self,
                                                                        GAsyncReadyCallback _callback_,
                                                                        gpointer _user_data_);
void sequeler_services_password_manager_clear_all_passwords_async (SequelerServicesPasswordManager* self,
                                                                   GAsyncReadyCallback _callback_,
                                                                   gpointer _user_data_);
void sequeler_services_password_manager_clear_all_passwords_finish (SequelerServicesPasswordManager* self,
                                                                    GAsyncResult* _res_,
                                                                    GError** error);
static gboolean sequeler_services_password_manager_real_clear_all_passwords_async_co (SequelerServicesPasswordManagerClearAllPasswordsAsyncData* _data_);
static void sequeler_services_password_manager_clear_all_passwords_async_ready (GObject* source_object,
                                                                         GAsyncResult* _res_,
                                                                         gpointer _user_data_);
SequelerServicesPasswordManager* sequeler_services_password_manager_new (void);
SequelerServicesPasswordManager* sequeler_services_password_manager_construct (GType object_type);


static void
sequeler_services_password_manager_real_store_password_async_data_free (gpointer _data)
{
	SequelerServicesPasswordManagerStorePasswordAsyncData* _data_;
	_data_ = _data;
	_g_free0 (_data_->id);
	_g_free0 (_data_->password);
	_g_object_unref0 (_data_->self);
	g_slice_free (SequelerServicesPasswordManagerStorePasswordAsyncData, _data_);
}


static void
sequeler_services_password_manager_real_store_password_async_async_ready_wrapper (GObject *source_object,
                                                                                  GAsyncResult *res,
                                                                                  void *user_data)
{
	SequelerServicesPasswordManagerStorePasswordAsyncData* _task_data_;
	_task_data_ = g_task_get_task_data (G_TASK (res));
	if (_task_data_->_callback_ != NULL) {
		_task_data_->_callback_ (source_object, res, user_data);
	}
	_task_data_->_task_complete_ = TRUE;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
sequeler_services_password_manager_real_store_password_async (SequelerServicesPasswordManager* self,
                                                              const gchar* id,
                                                              const gchar* password,
                                                              GAsyncReadyCallback _callback_,
                                                              gpointer _user_data_)
{
	SequelerServicesPasswordManagerStorePasswordAsyncData* _data_;
	SequelerServicesPasswordManager* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	_data_ = g_slice_new0 (SequelerServicesPasswordManagerStorePasswordAsyncData);
	_data_->_callback_ = _callback_;
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, sequeler_services_password_manager_real_store_password_async_async_ready_wrapper, _user_data_);
	if (_callback_ == NULL) {
		_data_->_task_complete_ = TRUE;
	}
	g_task_set_task_data (_data_->_async_result, _data_, sequeler_services_password_manager_real_store_password_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (id);
	_g_free0 (_data_->id);
	_data_->id = _tmp1_;
	_tmp2_ = g_strdup (password);
	_g_free0 (_data_->password);
	_data_->password = _tmp2_;
	sequeler_services_password_manager_real_store_password_async_co (_data_);
}


static void
sequeler_services_password_manager_real_store_password_finish (SequelerServicesPasswordManager* self,
                                                               GAsyncResult* _res_,
                                                               GError** error)
{
	SequelerServicesPasswordManagerStorePasswordAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return;
	}
}


static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}


static void
sequeler_services_password_manager_store_password_async_ready (GObject* source_object,
                                                               GAsyncResult* _res_,
                                                               gpointer _user_data_)
{
	SequelerServicesPasswordManagerStorePasswordAsyncData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	_data_->_task_complete_ = TRUE;
	sequeler_services_password_manager_real_store_password_async_co (_data_);
}


static gboolean
sequeler_services_password_manager_real_store_password_async_co (SequelerServicesPasswordManagerStorePasswordAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = g_str_hash;
	_data_->_tmp1_ = g_str_equal;
	_data_->_tmp2_ = g_hash_table_new_full (_data_->_tmp0_, _data_->_tmp1_, _g_free0_, _g_free0_);
	_data_->attributes = _data_->_tmp2_;
	_data_->_tmp3_ = g_strdup ("id");
	_data_->_tmp4_ = g_strdup (_data_->id);
	g_hash_table_insert (_data_->attributes, _data_->_tmp3_, _data_->_tmp4_);
	_data_->_tmp5_ = g_strdup ("schema");
	_data_->_tmp6_ = g_strdup (CONSTANTS_PROJECT_NAME);
	g_hash_table_insert (_data_->attributes, _data_->_tmp5_, _data_->_tmp6_);
	_data_->_tmp7_ = g_strconcat (CONSTANTS_PROJECT_NAME ".", _data_->id, NULL);
	_data_->key_name = _data_->_tmp7_;
	_data_->_tmp8_ = sequeler_schema;
	_data_->_state_ = 1;
	secret_password_storev (_data_->_tmp8_, _data_->attributes, SECRET_COLLECTION_DEFAULT, _data_->key_name, _data_->password, NULL, sequeler_services_password_manager_store_password_async_ready, _data_);
	return FALSE;
	_state_1:
	_data_->_result_ = secret_password_store_finish (_data_->_res_, &_data_->_inner_error_);
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
		_g_free0 (_data_->key_name);
		_g_hash_table_unref0 (_data_->attributes);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	if (!_data_->_result_) {
		g_debug ("PasswordManager.vala:35: Unable to store password for \"%s\" in libsec" \
"ret keyring", _data_->key_name);
	}
	_g_free0 (_data_->key_name);
	_g_hash_table_unref0 (_data_->attributes);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (_data_->_task_complete_ != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


void
sequeler_services_password_manager_store_password_async (SequelerServicesPasswordManager* self,
                                                         const gchar* id,
                                                         const gchar* password,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_)
{
	SEQUELER_SERVICES_PASSWORD_MANAGER_GET_CLASS (self)->store_password_async (self, id, password, _callback_, _user_data_);
}


void
sequeler_services_password_manager_store_password_finish (SequelerServicesPasswordManager* self,
                                                          GAsyncResult* _res_,
                                                          GError** error)
{
	SEQUELER_SERVICES_PASSWORD_MANAGER_GET_CLASS (self)->store_password_finish (self, _res_, error);
}


static void
sequeler_services_password_manager_real_get_password_async_data_free (gpointer _data)
{
	SequelerServicesPasswordManagerGetPasswordAsyncData* _data_;
	_data_ = _data;
	_g_free0 (_data_->id);
	_g_free0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (SequelerServicesPasswordManagerGetPasswordAsyncData, _data_);
}


static void
sequeler_services_password_manager_real_get_password_async_async_ready_wrapper (GObject *source_object,
                                                                                GAsyncResult *res,
                                                                                void *user_data)
{
	SequelerServicesPasswordManagerGetPasswordAsyncData* _task_data_;
	_task_data_ = g_task_get_task_data (G_TASK (res));
	if (_task_data_->_callback_ != NULL) {
		_task_data_->_callback_ (source_object, res, user_data);
	}
	_task_data_->_task_complete_ = TRUE;
}


static void
sequeler_services_password_manager_real_get_password_async (SequelerServicesPasswordManager* self,
                                                            const gchar* id,
                                                            GAsyncReadyCallback _callback_,
                                                            gpointer _user_data_)
{
	SequelerServicesPasswordManagerGetPasswordAsyncData* _data_;
	SequelerServicesPasswordManager* _tmp0_;
	gchar* _tmp1_;
	_data_ = g_slice_new0 (SequelerServicesPasswordManagerGetPasswordAsyncData);
	_data_->_callback_ = _callback_;
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, sequeler_services_password_manager_real_get_password_async_async_ready_wrapper, _user_data_);
	if (_callback_ == NULL) {
		_data_->_task_complete_ = TRUE;
	}
	g_task_set_task_data (_data_->_async_result, _data_, sequeler_services_password_manager_real_get_password_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (id);
	_g_free0 (_data_->id);
	_data_->id = _tmp1_;
	sequeler_services_password_manager_real_get_password_async_co (_data_);
}


static gchar*
sequeler_services_password_manager_real_get_password_finish (SequelerServicesPasswordManager* self,
                                                             GAsyncResult* _res_,
                                                             GError** error)
{
	gchar* result;
	SequelerServicesPasswordManagerGetPasswordAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return NULL;
	}
	result = _data_->result;
	_data_->result = NULL;
	return result;
}


static void
sequeler_services_password_manager_get_password_async_ready (GObject* source_object,
                                                             GAsyncResult* _res_,
                                                             gpointer _user_data_)
{
	SequelerServicesPasswordManagerGetPasswordAsyncData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	_data_->_task_complete_ = TRUE;
	sequeler_services_password_manager_real_get_password_async_co (_data_);
}


static gboolean
sequeler_services_password_manager_real_get_password_async_co (SequelerServicesPasswordManagerGetPasswordAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = g_str_hash;
	_data_->_tmp1_ = g_str_equal;
	_data_->_tmp2_ = g_hash_table_new_full (_data_->_tmp0_, _data_->_tmp1_, _g_free0_, _g_free0_);
	_data_->attributes = _data_->_tmp2_;
	_data_->_tmp3_ = g_strdup ("id");
	_data_->_tmp4_ = g_strdup (_data_->id);
	g_hash_table_insert (_data_->attributes, _data_->_tmp3_, _data_->_tmp4_);
	_data_->_tmp5_ = g_strdup ("schema");
	_data_->_tmp6_ = g_strdup (CONSTANTS_PROJECT_NAME);
	g_hash_table_insert (_data_->attributes, _data_->_tmp5_, _data_->_tmp6_);
	_data_->_tmp7_ = g_strconcat (CONSTANTS_PROJECT_NAME ".", _data_->id, NULL);
	_data_->key_name = _data_->_tmp7_;
	_data_->_tmp8_ = sequeler_schema;
	_data_->_state_ = 1;
	secret_password_lookupv (_data_->_tmp8_, _data_->attributes, NULL, sequeler_services_password_manager_get_password_async_ready, _data_);
	return FALSE;
	_state_1:
	_data_->_tmp9_ = secret_password_lookup_finish (_data_->_res_, &_data_->_inner_error_);
	_data_->password = _data_->_tmp9_;
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
		_g_free0 (_data_->key_name);
		_g_hash_table_unref0 (_data_->attributes);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	if (_data_->password == NULL) {
		g_debug ("PasswordManager.vala:49: Unable to fetch password in libsecret keyring" \
" for %s", _data_->key_name);
	}
	_data_->result = _data_->password;
	_g_free0 (_data_->key_name);
	_g_hash_table_unref0 (_data_->attributes);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (_data_->_task_complete_ != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


void
sequeler_services_password_manager_get_password_async (SequelerServicesPasswordManager* self,
                                                       const gchar* id,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_)
{
	SEQUELER_SERVICES_PASSWORD_MANAGER_GET_CLASS (self)->get_password_async (self, id, _callback_, _user_data_);
}


gchar*
sequeler_services_password_manager_get_password_finish (SequelerServicesPasswordManager* self,
                                                        GAsyncResult* _res_,
                                                        GError** error)
{
	return SEQUELER_SERVICES_PASSWORD_MANAGER_GET_CLASS (self)->get_password_finish (self, _res_, error);
}


static void
sequeler_services_password_manager_real_clear_password_async_data_free (gpointer _data)
{
	SequelerServicesPasswordManagerClearPasswordAsyncData* _data_;
	_data_ = _data;
	_g_free0 (_data_->id);
	_g_object_unref0 (_data_->self);
	g_slice_free (SequelerServicesPasswordManagerClearPasswordAsyncData, _data_);
}


static void
sequeler_services_password_manager_real_clear_password_async_async_ready_wrapper (GObject *source_object,
                                                                                  GAsyncResult *res,
                                                                                  void *user_data)
{
	SequelerServicesPasswordManagerClearPasswordAsyncData* _task_data_;
	_task_data_ = g_task_get_task_data (G_TASK (res));
	if (_task_data_->_callback_ != NULL) {
		_task_data_->_callback_ (source_object, res, user_data);
	}
	_task_data_->_task_complete_ = TRUE;
}


static void
sequeler_services_password_manager_real_clear_password_async (SequelerServicesPasswordManager* self,
                                                              const gchar* id,
                                                              GAsyncReadyCallback _callback_,
                                                              gpointer _user_data_)
{
	SequelerServicesPasswordManagerClearPasswordAsyncData* _data_;
	SequelerServicesPasswordManager* _tmp0_;
	gchar* _tmp1_;
	_data_ = g_slice_new0 (SequelerServicesPasswordManagerClearPasswordAsyncData);
	_data_->_callback_ = _callback_;
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, sequeler_services_password_manager_real_clear_password_async_async_ready_wrapper, _user_data_);
	if (_callback_ == NULL) {
		_data_->_task_complete_ = TRUE;
	}
	g_task_set_task_data (_data_->_async_result, _data_, sequeler_services_password_manager_real_clear_password_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (id);
	_g_free0 (_data_->id);
	_data_->id = _tmp1_;
	sequeler_services_password_manager_real_clear_password_async_co (_data_);
}


static void
sequeler_services_password_manager_real_clear_password_finish (SequelerServicesPasswordManager* self,
                                                               GAsyncResult* _res_,
                                                               GError** error)
{
	SequelerServicesPasswordManagerClearPasswordAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return;
	}
}


static void
sequeler_services_password_manager_clear_password_async_ready (GObject* source_object,
                                                               GAsyncResult* _res_,
                                                               gpointer _user_data_)
{
	SequelerServicesPasswordManagerClearPasswordAsyncData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	_data_->_task_complete_ = TRUE;
	sequeler_services_password_manager_real_clear_password_async_co (_data_);
}


static gboolean
sequeler_services_password_manager_real_clear_password_async_co (SequelerServicesPasswordManagerClearPasswordAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = g_str_hash;
	_data_->_tmp1_ = g_str_equal;
	_data_->_tmp2_ = g_hash_table_new_full (_data_->_tmp0_, _data_->_tmp1_, _g_free0_, _g_free0_);
	_data_->attributes = _data_->_tmp2_;
	_data_->_tmp3_ = g_strdup ("id");
	_data_->_tmp4_ = g_strdup (_data_->id);
	g_hash_table_insert (_data_->attributes, _data_->_tmp3_, _data_->_tmp4_);
	_data_->_tmp5_ = g_strdup ("schema");
	_data_->_tmp6_ = g_strdup (CONSTANTS_PROJECT_NAME);
	g_hash_table_insert (_data_->attributes, _data_->_tmp5_, _data_->_tmp6_);
	_data_->_tmp7_ = g_strconcat (CONSTANTS_PROJECT_NAME ".", _data_->id, NULL);
	_data_->key_name = _data_->_tmp7_;
	_data_->_tmp8_ = sequeler_schema;
	_data_->_state_ = 1;
	secret_password_clearv (_data_->_tmp8_, _data_->attributes, NULL, sequeler_services_password_manager_clear_password_async_ready, _data_);
	return FALSE;
	_state_1:
	_data_->removed = secret_password_clear_finish (_data_->_res_, &_data_->_inner_error_);
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
		_g_free0 (_data_->key_name);
		_g_hash_table_unref0 (_data_->attributes);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	if (!_data_->removed) {
		g_debug ("PasswordManager.vala:65: Unable to clear password in libsecret keyring" \
" for %s", _data_->key_name);
	}
	_g_free0 (_data_->key_name);
	_g_hash_table_unref0 (_data_->attributes);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (_data_->_task_complete_ != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


void
sequeler_services_password_manager_clear_password_async (SequelerServicesPasswordManager* self,
                                                         const gchar* id,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_)
{
	SEQUELER_SERVICES_PASSWORD_MANAGER_GET_CLASS (self)->clear_password_async (self, id, _callback_, _user_data_);
}


void
sequeler_services_password_manager_clear_password_finish (SequelerServicesPasswordManager* self,
                                                          GAsyncResult* _res_,
                                                          GError** error)
{
	SEQUELER_SERVICES_PASSWORD_MANAGER_GET_CLASS (self)->clear_password_finish (self, _res_, error);
}


static void
sequeler_services_password_manager_real_clear_all_passwords_async_data_free (gpointer _data)
{
	SequelerServicesPasswordManagerClearAllPasswordsAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (SequelerServicesPasswordManagerClearAllPasswordsAsyncData, _data_);
}


static void
sequeler_services_password_manager_real_clear_all_passwords_async_async_ready_wrapper (GObject *source_object,
                                                                                       GAsyncResult *res,
                                                                                       void *user_data)
{
	SequelerServicesPasswordManagerClearAllPasswordsAsyncData* _task_data_;
	_task_data_ = g_task_get_task_data (G_TASK (res));
	if (_task_data_->_callback_ != NULL) {
		_task_data_->_callback_ (source_object, res, user_data);
	}
	_task_data_->_task_complete_ = TRUE;
}


static void
sequeler_services_password_manager_real_clear_all_passwords_async (SequelerServicesPasswordManager* self,
                                                                   GAsyncReadyCallback _callback_,
                                                                   gpointer _user_data_)
{
	SequelerServicesPasswordManagerClearAllPasswordsAsyncData* _data_;
	SequelerServicesPasswordManager* _tmp0_;
	_data_ = g_slice_new0 (SequelerServicesPasswordManagerClearAllPasswordsAsyncData);
	_data_->_callback_ = _callback_;
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, sequeler_services_password_manager_real_clear_all_passwords_async_async_ready_wrapper, _user_data_);
	if (_callback_ == NULL) {
		_data_->_task_complete_ = TRUE;
	}
	g_task_set_task_data (_data_->_async_result, _data_, sequeler_services_password_manager_real_clear_all_passwords_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	sequeler_services_password_manager_real_clear_all_passwords_async_co (_data_);
}


static void
sequeler_services_password_manager_real_clear_all_passwords_finish (SequelerServicesPasswordManager* self,
                                                                    GAsyncResult* _res_,
                                                                    GError** error)
{
	SequelerServicesPasswordManagerClearAllPasswordsAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return;
	}
}


static void
sequeler_services_password_manager_clear_all_passwords_async_ready (GObject* source_object,
                                                                    GAsyncResult* _res_,
                                                                    gpointer _user_data_)
{
	SequelerServicesPasswordManagerClearAllPasswordsAsyncData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	_data_->_task_complete_ = TRUE;
	sequeler_services_password_manager_real_clear_all_passwords_async_co (_data_);
}


static gboolean
sequeler_services_password_manager_real_clear_all_passwords_async_co (SequelerServicesPasswordManagerClearAllPasswordsAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = g_str_hash;
	_data_->_tmp1_ = g_str_equal;
	_data_->_tmp2_ = g_hash_table_new_full (_data_->_tmp0_, _data_->_tmp1_, _g_free0_, _g_free0_);
	_data_->attributes = _data_->_tmp2_;
	_data_->_tmp3_ = g_strdup ("schema");
	_data_->_tmp4_ = g_strdup (CONSTANTS_PROJECT_NAME);
	g_hash_table_insert (_data_->attributes, _data_->_tmp3_, _data_->_tmp4_);
	_data_->_tmp5_ = sequeler_schema;
	_data_->_state_ = 1;
	secret_password_clearv (_data_->_tmp5_, _data_->attributes, NULL, sequeler_services_password_manager_clear_all_passwords_async_ready, _data_);
	return FALSE;
	_state_1:
	_data_->removed = secret_password_clear_finish (_data_->_res_, &_data_->_inner_error_);
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
		_g_hash_table_unref0 (_data_->attributes);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	if (!_data_->removed) {
		g_debug ("PasswordManager.vala:76: Unable to clear all passwords in libsecret");
	}
	_g_hash_table_unref0 (_data_->attributes);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (_data_->_task_complete_ != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


void
sequeler_services_password_manager_clear_all_passwords_async (SequelerServicesPasswordManager* self,
                                                              GAsyncReadyCallback _callback_,
                                                              gpointer _user_data_)
{
	SEQUELER_SERVICES_PASSWORD_MANAGER_GET_CLASS (self)->clear_all_passwords_async (self, _callback_, _user_data_);
}


void
sequeler_services_password_manager_clear_all_passwords_finish (SequelerServicesPasswordManager* self,
                                                               GAsyncResult* _res_,
                                                               GError** error)
{
	SEQUELER_SERVICES_PASSWORD_MANAGER_GET_CLASS (self)->clear_all_passwords_finish (self, _res_, error);
}


SequelerServicesPasswordManager*
sequeler_services_password_manager_construct (GType object_type)
{
	SequelerServicesPasswordManager * self = NULL;
	self = (SequelerServicesPasswordManager*) g_object_new (object_type, NULL);
	return self;
}


SequelerServicesPasswordManager*
sequeler_services_password_manager_new (void)
{
	return sequeler_services_password_manager_construct (SEQUELER_SERVICES_TYPE_PASSWORD_MANAGER);
}


static void
sequeler_services_password_manager_class_init (SequelerServicesPasswordManagerClass * klass)
{
	sequeler_services_password_manager_parent_class = g_type_class_peek_parent (klass);
	((SequelerServicesPasswordManagerClass *) klass)->store_password_async = (void (*) (SequelerServicesPasswordManager *, const gchar*, const gchar*, GAsyncReadyCallback, gpointer)) sequeler_services_password_manager_real_store_password_async;
	((SequelerServicesPasswordManagerClass *) klass)->store_password_finish = (void (*) (SequelerServicesPasswordManager *, GAsyncResult*, GError**)) sequeler_services_password_manager_real_store_password_finish;
	((SequelerServicesPasswordManagerClass *) klass)->get_password_async = (void (*) (SequelerServicesPasswordManager *, const gchar*, GAsyncReadyCallback, gpointer)) sequeler_services_password_manager_real_get_password_async;
	((SequelerServicesPasswordManagerClass *) klass)->get_password_finish = (gchar* (*) (SequelerServicesPasswordManager *, GAsyncResult*, GError**)) sequeler_services_password_manager_real_get_password_finish;
	((SequelerServicesPasswordManagerClass *) klass)->clear_password_async = (void (*) (SequelerServicesPasswordManager *, const gchar*, GAsyncReadyCallback, gpointer)) sequeler_services_password_manager_real_clear_password_async;
	((SequelerServicesPasswordManagerClass *) klass)->clear_password_finish = (void (*) (SequelerServicesPasswordManager *, GAsyncResult*, GError**)) sequeler_services_password_manager_real_clear_password_finish;
	((SequelerServicesPasswordManagerClass *) klass)->clear_all_passwords_async = (void (*) (SequelerServicesPasswordManager *, GAsyncReadyCallback, gpointer)) sequeler_services_password_manager_real_clear_all_passwords_async;
	((SequelerServicesPasswordManagerClass *) klass)->clear_all_passwords_finish = (void (*) (SequelerServicesPasswordManager *, GAsyncResult*, GError**)) sequeler_services_password_manager_real_clear_all_passwords_finish;
}


static void
sequeler_services_password_manager_instance_init (SequelerServicesPasswordManager * self)
{
}


GType
sequeler_services_password_manager_get_type (void)
{
	static volatile gsize sequeler_services_password_manager_type_id__volatile = 0;
	if (g_once_init_enter (&sequeler_services_password_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SequelerServicesPasswordManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sequeler_services_password_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SequelerServicesPasswordManager), 0, (GInstanceInitFunc) sequeler_services_password_manager_instance_init, NULL };
		GType sequeler_services_password_manager_type_id;
		sequeler_services_password_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "SequelerServicesPasswordManager", &g_define_type_info, 0);
		g_once_init_leave (&sequeler_services_password_manager_type_id__volatile, sequeler_services_password_manager_type_id);
	}
	return sequeler_services_password_manager_type_id__volatile;
}



